SuperStrict
Framework brl.standardio
Import brl.blitz
Import brl.filesystem
Import brl.stream
Import brl.retro




Global path$="code.txt"
If AppArgs.length>1 Then
	Local ona%=0
	For Local a$=EachIn AppArgs
		ona:+1
		If ona=2 Then path=a
	Next
EndIf






Global code@[1]

Local fil:TStream=ReadFile(path)
If Not fil Print "Could not load "+path;Input;End

Global csize:Long=0,comment%=0

Local index:Long=0
Global cmds$="0123456789abcdef"
Repeat
	Local lin$=Lower(ReadLine(fil))
	Local s%=1
	For Local s%=1 To Len(lin)
		Local c$=Mid(lin,s,1)
		If c="/" Then 
			comment=Not comment
		ElseIf comment=0 And Instr(cmds,c) Then
			csize:+1
			code=code[..csize+18]
			Local n%=0
			Select c
				Case "0" n=0
				Case "1" n=1
				Case "2" n=2
				Case "3" n=3
				Case "4" n=4
				Case "5" n=5
				Case "6" n=6
				Case "7" n=7
				Case "8" n=8
				Case "9" n=9
				Case "a" n=10
				Case "b" n=11
				Case "c" n=12
				Case "d" n=13
				Case "e" n=14
				Case "f" n=15
			End Select
			code[csize-1]=n
		EndIf
	Next
Until Eof(fil)
CloseFile fil


Global msize:Long=64

Global memory@[msize]
Global mmod:Long=0
Function get@(x:Long)
	If x+mmod<0 Then 
		mmod=-x;memory=memory[..msize+mmod]
		For Local rsize%=0 To msize+mmod-2
			memory[msize+mmod-1-rsize]=memory[msize+mmod-2-rsize]
		Next
		memory[0]=0
	EndIf
	If x=>msize Then msize:+1;memory=memory[..msize+mmod]
	If x+mmod<0
		Print msize+mmod
		Print x+mmod
	EndIf
	Return memory[x+mmod]
End Function
Function set(x:Long,s@)
	get x
	memory[x+mmod]=s
End Function

Global mempos:Long=36


Global flow%=1 '1 means forward 0 means back
Global openbracket%[],looking%=0

Global lastcode%=0,nops%=0


Function push(stack%[] Var,val%)
	Local n:Long=stack.length
	stack=stack[..n+1]
	stack[n]=val
End Function
Function pop%(stack%[] Var)
	Local n:Long=stack.length
	If Not n Return 0
	Local r%=stack[n-1]
	stack=stack[..n-1]
	Return r
End Function


Global written$=""








Print "Executing "+path
Print ""

Function execute(limit%=0)
	written=""
	Global pos:Long=0,skip%=0,runtime%=0
	Repeat
		runtime:+1
		If limit>0 And runtime=>limit Then Return
		If skip=0 
			pos=dochar(code,csize,pos)
			If pos<0 Then Exit
		Else
			skip:-1
		EndIf
		If flow pos:+1 Else pos:-1
	Forever
End Function

execute



Print ""
Print ""
Print "Execution complete."
Input
End







Function dochar:Long(docode@[],docodelen:Long,pos:Long,debug%=0)
	Local ds$=Abs(docode[pos]-lastcode)+" : "
	If pos<0
		While pos<0
			pos:+csize
		Wend
	EndIf
	pos=pos Mod csize
	Local thislastcode%=docode[pos]
	'Print Abs(docode[pos]-lastcode)
	Select Abs(docode[pos]-lastcode)
		Case 00 
			If looking=0 
				mempos:-1
				ds:+"<"
			EndIf
		Case 01 
			If looking=0 
				mempos:+1
				ds:+">"
			EndIf
		Case 02 
			If looking=0 
				set(mempos,get(mempos)+1)
				ds:+"+"
			EndIf
		Case 03 
			If looking=0 
				set(mempos,get(mempos)-1)
				ds:+"-"
			EndIf
		Case 04 
			If looking=0 
				set(mempos,Int(Input("")));written:+"?INPUT"
				ds:+","
			EndIf
		Case 05 
			If looking=0 
				StandardIOStream.WriteString Int(get(mempos));written:+get(mempos)
				ds:+"."
			EndIf
		Case 06 
			If looking=0 
				StandardIOStream.WriteString Chr(get(mempos));written:+Chr(get(mempos))
				ds:+":"
			EndIf
		Case 07,13
			If flow=1
				If looking
					looking:+1
				Else
					If get(mempos)=0 Then
						looking=1
					Else
						push(openbracket,pos)
					EndIf
					ds:+"["
				EndIf
			Else
				If looking Then
					looking:-1
				Else
					pos=pop(openbracket)
					ds:+"]"
				EndIf
			EndIf
		Case 08,14 
			If flow=1
				If looking Then
					looking:-1
				Else
					pos=pop(openbracket)
					ds:+"]"
				EndIf
			Else
				If looking
					looking:+1
				Else
					If get(mempos)=0 Then
						looking=1
					Else
						push(openbracket,pos)
					EndIf
					ds:+"["
				EndIf
			EndIf
		Case 09
			If looking=0 
				set(mempos,rotl(get(mempos)))
				ds:+"("
			EndIf
		Case 10
			If looking=0
				pos:+8
				ds:+"}"
			EndIf
		Case 11 
			If looking=0 
				pos:-8
				ds:+"{"
			EndIf
		Case 12 
			If looking=0
				flow=Not flow
				ds:+"@"
			EndIf
		Case 15 
			If looking=0 
				nops:+1
				ds:+"_"
			EndIf
	End Select
	If Abs(docode[pos]-lastcode)<>15 nops=0
	If nops=>2 Then Return -1
	If pos<0
		While pos<0
			pos:+csize
		Wend
	EndIf
	pos=pos Mod csize
	lastcode=thislastcode
	If debug Print ds
	Return pos
End Function


Function printcode(array@[],size:Long)
	Local out$=""
	For Local x%=0 To size-1
		out:+Chr(array[x])
	Next
	Print out
End Function


Function match:Long(docode@[],docodelen:Long,start:Long,inc$,dec$,dir%)
	Local nest:Long=1,in:Long=start+dir
	Repeat
		If in=>docodelen Or in<0 
			printcode docode,docodelen
			Print "ERROR: could not find matching "+dec;Input;End
		EndIf
		If Chr(docode[in])=inc And inc<>dec Then nest:+1
		If Chr(docode[in])=dec nest:-1
		If nest=0 Return in
		in:+dir
	Forever
End Function

Function bottles()
	For Local x%=0 To 96
		Print (99-x)+" bottles of beer on the wall, "+(99-x)+" bottles of beer."
		Print "Take one down, pass it around. "+(98-x)+" bottles of beer on the wall."
	Next
	Print "2 bottles of beer on the wall, 2 bottles of beer."
	Print "Take one down, pass it around. 1 bottle of beer on the wall."
	Print "1 bottle of beer on the wall, 1 bottle of beer."
	Print "Take it down, pass it around. No more bottles of beer on the wall."
	Print "No more bottles of beer on the wall, no more bottles of beer."
	Print "Go to the store and buy some more. 99 bottles of beer on the wall."
End Function

Function fib()
	Local s$="1 1"
	Local a%=1,b%=1,c%=0
	For Local x%=1 To 14
		c=b
		b=a+b
		a=c
		s:+" "+b
	Next
	StandardIOStream.WriteString s
End Function

Function collatz(n%)
	StandardIOStream.WriteString n
	Repeat
		If n=1 Exit
		If n Mod 2=0 n:/2 Else n:*3;n:+1
		StandardIOStream.WriteString " "+n
	Until n=1
End Function

Function masculinity%(n%)
	If n=0 Or n=2 Return 0
	If n=1 Return 1
	Local factors%=0
	For Local x%=2 To n/2
		If n Mod x=0 Then factors:+1
	Next
	Local score%=n/2/factors+(n<0)*2
	Return score
End Function





Function Rotl%(v%)
	Return (v Shl 1) + (v Shr 31)
End Function

Function Rotr%(v%)
	Return (v Shr 1) + (v Shl 31)
End Function












